# Copyright (c) 2025, NVIDIA CORPORATION.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# To run this recipe:
#   automodel examples/vlm_finetune/qwen3/qwen3_omni_moe_30b_te_deepep.yaml --nproc-per-node 8
# Adjust --nproc-per-node to the number of GPUs available on your machine.

recipe: FinetuneRecipeForVLM

step_scheduler:
  global_batch_size: 32
  local_batch_size: 1
  ckpt_every_steps: 500
  val_every_steps: 100  # will run every x number of gradient steps
  num_epochs: 2
  # max_steps: 200

dist_env:
  backend: nccl
  timeout_minutes: 10

rng:
  _target_: nemo_automodel.components.training.rng.StatefulRNG
  seed: 1111
  ranked: true

model:
  _target_: nemo_automodel.NeMoAutoModelForMultimodalLM.from_pretrained
  pretrained_model_name_or_path: Qwen/Qwen3-Omni-30B-A3B-Instruct
  #Customize this backend for fine grained control
  backend:
    _target_: nemo_automodel.components.models.common.BackendConfig
    attn: sdpa
    linear: te
    rms_norm: torch_fp32
    rope_fusion: false
    experts: te
    enable_deepep: true
    fake_balanced_gate: false
    enable_hf_state_dict_adapter: true


checkpoint:
  enabled: false
  checkpoint_dir: /tmp/checkpoints/
  model_save_format: safetensors # torch_save or safetensors
  save_consolidated: true # saves the model in a consolidated safetensors format. Requires model_save_format to be safetensors.

distributed:
  strategy: fsdp2
  tp_size: 1
  cp_size: 1
  pp_size: 1
  ep_size: 8

  sequence_parallel: false

freeze_config:
  freeze_embeddings: false
  freeze_vision_tower: true
  freeze_audio_tower: true
  freeze_language_model: false

loss_fn:
  _target_: nemo_automodel.components.loss.masked_ce.MaskedCrossEntropy

dataset:
  _target_: nemo_automodel.components.datasets.vlm.datasets.make_medpix_dataset
  path_or_dataset: mmoukouba/MedPix-VQA
  split: train[:1000]

dataloader:
  _target_: torchdata.stateful_dataloader.StatefulDataLoader
  num_workers: 1
  collate_fn:
    _target_: nemo_automodel.components.datasets.vlm.collate_fns.qwen3_omni_collate_fn

validation_dataset:
  _target_: nemo_automodel.components.datasets.vlm.datasets.make_medpix_dataset
  path_or_dataset: mmoukouba/MedPix-VQA
  split: validation[:100]

validation_dataloader:
  _target_: torchdata.stateful_dataloader.StatefulDataLoader
  num_workers: 1
  collate_fn:
    _target_: nemo_automodel.components.datasets.vlm.collate_fns.qwen3_omni_collate_fn

optimizer:
  _target_: torch.optim.Adam
  betas: [0.9, 0.95]
  eps: 1e-7
  lr: 1.0e-4
  weight_decay: 0.0
  # min_lr: 1.0e-5

# Uncomment and configure for W&B logging
# wandb:
#   project: <your_wandb_project>
#   entity: <your_wandb_entity>
#   name: <your_wandb_exp_name>
#   save_dir: <your_wandb_save_dir>



ci:
  recipe_owner: HuiyingLi
  time: "00:30:00"
